
/**
 * This class represents a session in showboat
 * 
 * @author Michael E. Caspersen, Jens Benendsen 
 * @version 20 April 2001<br>
 * Revision: <br>
 * 22 December 1998: Created<br>
 * 20 April 2001: Javadoc added
 * 26 April 2009. Changed by Gries
 * 
 */
class Session {
      
    private int nr; // the number of this session.
    private Time startTime; // start time (0 if not set).
    private Time stopTime; // end time (0 if note set).
    
    /** Constructor: a Session with number nr. It is NOT started. */
    public Session (int nr) {
        this.nr= nr;
    }
    
    /** = this session's number. */
    public int getNr() {
        return nr;
    }
    
    /** Start this session at the current time. */
    public void start () {
        startTime= new Time();
    }
    
    /** End this session at the current time. */
    public void stop () {
        stopTime= new Time();
    }
    
    /** = the duration of this session.
          Precondition: this session was stopped by a call on stop. */
    public Time duration () {
        return stopTime.subtract(startTime);
    }
    
    /** = A string representation of this Session. */
    public String toString() {
        String str= 
            "Nr:       "  +  nr  +  "\n"  +
            "Start:    "  +  startTime.toString()   +  "\n"  +
            "Stop:     "  +  stopTime.toString()    +  "\n"  +
            "Duration: "  +  duration().toString()  +  "\n";
        return str;
    }
    
    /** = ob is a Session and has the same number as this one. */
    public boolean equals(Object ob) {
        return ob instanceof Session  &&  ((Session)ob).nr == nr;
    }

}